;========================================================================
;                                                                       =
;                          Geometry Solver v2.4                         =
;                           Right Circular Cone                         =
;                                                                       =
; Written By:   Morgan Davies (Morgazum85@Juno.com)                     =
; Date:         January 8, 2003                                         =
; Size:         687 Bytes                                               =
;                                                                       =
; Info: My next series in TI-86 is for Geometry. This program solves    =
;   for any varible from one equations relating to cones. Source has    =
;   been well documented.                                               =
;                                                                       =
;========================================================================

#include "ti86asm.inc"
#include "Asm86.h"
#include "Rom86.h"

;.plugin lite86;                     ;the ultimate compression rutine

_ioprompt   =$c324
_asap_ind   =$d623
_getcode    =$4068

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp Start                        ;jump to Start
    .dw 0                           ;type of input
    .dw String3                     ;print string

String3: .db "Cones",0
#include "BMP2ASM.asm"

Start:
    call _flushallmenus             ;clears all key codes
    call _clrScrn                   ;clears the lcd and graph screen
    call _runindicoff               ;turn off run indicator
    ld hl,Prgm-1                    ;loads hl with prgm name to execute
    rst 20h                         ;op1 = name of 2nd asm prog to call
    rst 10h                         ;call _findsym, see if variable exists
    jp c,Text3                      ;if not jump to Text3
    ld de,Picture                   ;load picture into de
    call decompV                    ;goes to decompV
    call _exec_assembly             ;execute prgm in op1
Start2:
    ld hl,$1A05                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String4                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$210A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String5                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3405                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String9                   ;loads hl with string
    call _vputs                     ;prints in small text

Equation1:
    ld hl,$2105                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3A0A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String10                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey1:
    call _getcode                   ;stores key pressed into a
    cp K_ALPHA                      ;compare a with ALPHA
    call z,CalcOff                  ;if ALPHA goe to CalcOff
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_F1                         ;compares a with F1
    jr z,VAR1                       ;if F1 relative jump to VAR1
    cp K_F2                         ;compares a with F2
    jr z,VAR2                       ;if F2 relative jump to VAR2
    cp K_F3                         ;compares a with F3
    jr z,VAR3                       ;if F3 relative jump to VAR3
    jr GetKey1                      ;relative jump to GetKey1

VAR1:
    call Text1                      ;goes to Text1
    ld hl,E2                        ;string to print
    call Input                      ;goes to Input
    ld hl,Pie                       ;load hl with Pie
    call _mov10toop2                ;move 10 bytes @ hl to OP2
    rst 28h                         ;OP1 * OP2 ==> OP1
    rst 08h                         ;OP1 ==> OP2
    ld hl,E3                        ;string to print
    call Input                      ;goes to Input
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    call _SQROOT                    ;square root of OP1 ==> OP1
    ld hl,E1                        ;string to print
    jr Text2                        ;realtive jump to Text2

VAR2:
    call Text4                      ;goes to Text4
    ld hl,E3                        ;string to print
    call Input                      ;goes to Input
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    ld hl,E2                        ;string to print
    jr Text2                        ;realtive jump to Text2

VAR3:
    call Text4                      ;goes to Text4
    ld hl,E2                        ;string to print
    call Input                      ;goes to Input
    rst 28h                         ;OP1 * OP2 ==> OP1
    ld hl,E3                        ;string to print
    jr Text2                        ;realtive jump to Text2

Text1:
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    ret                             ;return to call

Text2:
    call _puts                      ;prints string
    call DispAnswer                 ;goes to DispAnswer
    call _getkey                    ;waits for a key to be pressed
    jp Start                        ;jumps to Start

Text3:
    ld hl,$0000                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String1                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$0700                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String2                   ;loads hl with string
    call _vputs                     ;prints in small text
    call _getkey                    ;waits for a key to be pressed
    jp Start2                       ;jump to Start2

Text4:
    call Text1                      ;goes to Text1
    ld hl,E1                        ;string to print
    call Input                      ;goes to Input
    call _FPSQUARE                  ;OP1 ^2 ==> OP1
    ld hl,Pie                       ;load hl with Pie
    call _mov10toop2                ;move 10 bytes @ hl to OP2
    rst 28h                         ;OP1 * OP2 ==> OP1
    rst 08h                         ;OP1 ==> OP2
    ret                             ;return to call

Input:
    ld de,_ioprompt                 ;$c324 - string storage for display when prompte
    call _mov10b                    ;$427b - move 10 bytes from hl to de
    ld a,$0d                        ;type of input
                                    ;$0d - # value
                                    ;$0c - string
    ld (_asap_ind),a                ;$d623 - tell ti86 what kind to be inputted
    jp _exec_pg3                    ;$5714 - ti86 os input
                                    ;the number inputted is always stored to OP1
    ret                             ;return to call

DispAnswer:
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _puts                      ;prints answer
    call _runindicoff               ;turn off run indicator
    ret                             ;return to call

CalcOff:
    ld a,1
    out (3),a
    halt
    ld a,11                         ;turns off calculator???
    out (3),a        
    res onInterrupt,(iy+onflags)
    ret

Exit:
    res 3,(iy+5)                    ;reverts text back to black on white
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;moves cursor to upper left
    ret                             ;return that exits the program

Pie:                                ;Pie / 3
    .db $00,$00,$FC,$10,$47,$19,$75,$51,$20,$00

String1:    .db "Written By Morgan Davies",0
String2:    .db "Missing File      ",34,"-geo.86p",34,"",0
String4:    .db "Equations:",0
String5:    .db "Volume=(",196,"r",18,"H)/3",0
String8:    .db 5,0
String9:    .db "Solve For?",0
String10:   .db "F1= r     F2= H     F3= Volume",0
Prgm:       .db 4,"",45,"geo"
E1:     .db "r=?",0
E2:     .db "H=?",0
E3:     .db "Volume=?",0

Picture:
    .db $B7, $00, $FF, $B7, $00, $FF, $B7, $00, $71, $01, $02, $B7, $04, $04, $02, $01
    .db $B7, $00, $30, $01, $02, $04, $08, $10, $20, $4D, $D0, $80, $B7, $00, $06, $80
    .db $70, $0F, $B7, $00, $26, $01, $02, $04, $08, $10, $20, $40, $80, $B7, $00, $05
    .db $36, $C0, $B7, $00, $0A, $C0, $3F, $B7, $00, $22, $20, $50, $88, $24, $02, $21
    .db $00, $20, $00, $2A, $0A, $2E, $0A, $2A, $00, $20, $DB, $20, $00, $20, $00, $20
    .db $75, $20, $B7, $01, $04, $00, $FF, $B7, $00, $28, $80, $40, $20, $10, $08, $04
    .db $02, $01, $00, $00, $60, $1B, $B7, $00, $04, $55, $00, $40, $80, $00, $00, $1F
    .db $E0, $B7, $00, $30, $80, $40, $20, $90, $58, $0C, $02, $01, $55, $01, $01, $02
    .db $0C, $70, $80, $B7, $00, $48

.end
END