;========================================================================
;                                                                       =
;                          Geometry Solver v2.4                         =
;                                 Cubes                                 =
;                                                                       =
; Written By:   Morgan Davies (Morgazum85@Juno.com)                     =
; Date:         January 8, 2003                                         =
; Size:         774 Bytes                                               =
;                                                                       =
; Info: My next series in TI-86 is for Geometry. This program solves    =
;   for any varible from two different equations relating to cubes      =
;   Source has been well documented.                                    =
;                                                                       =
;========================================================================

#include "ti86asm.inc"
#include "Asm86.h"
#include "Rom86.h"

;.plugin lite86;                     ;the ultimate compression rutine

_ioprompt   =$c324
_asap_ind   =$d623
_getcode    =$4068

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp Start                        ;jump to Start
    .dw 0                           ;type of input
    .dw String3                     ;print string

String3: .db "Cubes",0
#include "BMP2ASM.asm"

Start:
    call _flushallmenus             ;clears all key codes
    call _clrScrn                   ;clears the lcd and graph screen
    call _runindicoff               ;turn off run indicator
    ld hl,Prgm-1                    ;loads hl with prgm name to execute
    rst 20h                         ;op1 = name of 2nd asm prog to call
    rst 10h                         ;call _findsym, see if variable exists
    jp c,Text3                      ;if not jump to Text3
    ld de,Picture                   ;load picture into de
    call decompV                    ;goes to decompV
    call _exec_assembly             ;execute prgm in op1
Start2:
    ld hl,$1A05                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String4                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$210A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String5                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$270A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String6                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3405                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String9                   ;loads hl with string
    call _vputs                     ;prints in small text

Equation1:
    ld hl,$2105                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2705                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String7                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3A0A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String10                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey1:
    call _getcode                   ;stores key pressed into a
    cp K_ALPHA                      ;compare a with ALPHA
    call z,CalcOff                  ;if ALPHA goe to CalcOff
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_DOWN                       ;compares a with DOWN
    jr z,Equation2                  ;if DOWN relative jump to Equation2
    cp K_F1                         ;compares a with F1
    jr z,VAR1                       ;if F1 relative jump to VAR1
    cp K_F2                         ;compares a with F2
    jr z,VAR2                       ;if F2 relative jump to VAR2
    jr GetKey1                      ;relative jump to GetKey1

Equation2:
    ld hl,$2105                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String7                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2705                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3A2D                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String11                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey2:
    call _getcode                   ;stores key pressed into a
    cp K_ALPHA                      ;compare a with ALPHA
    call z,CalcOff                  ;if ALPHA goe to CalcOff
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_UP                         ;compares a with UP
    jr z,Equation1                  ;if UP relative jump to Equation1
    cp K_F1                         ;compares a with F1
    jr z,VAR3                       ;if F1 relative jump to VAR3
    cp K_F2                         ;compares a with F2
    jr z,VAR4                       ;if F2 relative jump to VAR4
    jr GetKey2                      ;relative jump to GetKey2

VAR1:
    call Text1                      ;goes to Text1
    ld a,3                          ;loads a with 3
    call _setXXop2                  ;moves value @ a to OP2
    ld a,1                          ;loads a with 1
    call _setXXop1                  ;moves value @ a to OP1
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    rst 08h                         ;OP1 ==> OP2
    ld hl,E2                        ;string to print
    call Input                      ;goes to Input
    call _YTOX                      ;OP1 ^ OP2 ==> OP1
    ld hl,E1                        ;string to print
    jr Text2                        ;realtive jump to Text2

VAR2:
    call Text1                      ;goes to Text1
    ld a,3                          ;loads a with 3
    call _setXXop2                  ;moves value @ a to OP2
    ld hl,E1                        ;string to print
    call Input                      ;goes to Input
    call _YTOX                      ;OP1 ^ OP2 ==> OP1
    ld hl,E2                        ;string to print
    jr Text2                        ;realtive jump to Text2

VAR3:
    call Text1                      ;goes to Text1
    ld a,6                          ;loads a with 6
    call _setXXop2                  ;moves value @ a to OP2
    ld hl,E3                        ;string to print
    call Input                      ;goes to Input
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    call _SQROOT                    ;square root of OP1 ==> OP1
    ld hl,E1                        ;string to print
    jr Text2                        ;realtive jump to Text2

VAR4:
    call Text1                      ;goes to Text1
    ld hl,E1                        ;string to print
    call Input                      ;goes to Input
    call _FPSQUARE                  ;OP1 ^2 ==> OP1
    ld a,6                          ;loads a with 6
    call _setXXop2                  ;moves value @ a to OP2
    rst 28h                         ;OP1 * OP2 ==> OP1
    ld hl,E3                        ;string to print
    jr Text2                        ;realtive jump to Text2

Text1:
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    ret                             ;return to call

Text2:
    call _puts                      ;prints string
    call DispAnswer                 ;goes to DispAnswer
    call _getkey                    ;waits for a key to be pressed
    jp Start                        ;jumps to Start

Text3:
    ld hl,$0000                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String1                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$0700                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String2                   ;loads hl with string
    call _vputs                     ;prints in small text
    call _getkey                    ;waits for a key to be pressed
    jp Start2                       ;jump to Start2

Input:
    ld de,_ioprompt                 ;$c324 - string storage for display when prompte
    call _mov10b                    ;$427b - move 10 bytes from hl to de
    ld a,$0d                        ;type of input
                                    ;$0d - # value
                                    ;$0c - string
    ld (_asap_ind),a                ;$d623 - tell ti86 what kind to be inputted
    jp _exec_pg3                    ;$5714 - ti86 os input
                                    ;the number inputted is always stored to OP1
    ret                             ;return to call

DispAnswer:
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _puts                      ;prints answer
    call _runindicoff               ;turn off run indicator
    ret                             ;return to call

CalcOff:
    ld a,1
    out (3),a
    halt
    ld a,11                         ;turns off calculator???
    out (3),a        
    res onInterrupt,(iy+onflags)
    ret

Exit:
    res 3,(iy+5)                    ;reverts text back to black on white
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;moves cursor to upper left
    ret                             ;return that exits the program

String1:    .db "Written By Morgan Davies",0
String2:    .db "Missing File      ",34,"-geo.86p",34,"",0
String4:    .db "Equations:",0
String5:    .db "Volume=S^3",0
String6:    .db "Surface Area=6(S",18,")",0
String7:    .db 32,32,32,0
String8:    .db 5,0
String9:    .db "Solve For?",0
String10:   .db "F1= S     F2= Volume",0
String11:   .db "S. Area ",0
Prgm:       .db 4,"",45,"geo"
E1:     .db "S=?",0
E2:     .db "Volume=?",0
E3:     .db "S. Area=?",0

Picture:
    .db $B7, $00, $FF, $B7, $00, $FF, $B7, $00, $E2, $01, $02, $04, $06, $05, $B7, $04
    .db $0D, $02, $01, $B7, $00, $24, $01, $02, $04, $08, $10, $20, $40, $80, $B7, $00
    .db $05, $80, $40, $20, $10, $08, $04, $02, $B7, $01, $08, $81, $41, $21, $11, $09
    .db $05, $03, $01, $B7, $00, $1D, $80, $40, $20, $10, $08, $04, $02, $01, $00, $00
    .db $00, $01, $02, $04, $08, $10, $20, $40, $80, $B7, $00, $07, $01, $02, $04, $08
    .db $11, $22, $41, $80, $03, $B7, $00, $25, $80, $40, $C0, $B7, $40, $0E, $80, $B7
    .db $00, $04, $80, $00, $00, $80, $B7, $00, $46

.end
END