;========================================================================
;                                                                       =
;                          Geometry Solver v2.4                         =
;                                Cylinders                              =
;                                                                       =
; Written By:   Morgan Davies (Morgazum85@Juno.com)                     =
; Date:         January 7, 2003                                         =
; Size:         883 Bytes                                               =
;                                                                       =
; Info: My next series in TI-86 is for Geometry. This program solves    =
;   for any varible from two different equations relating to cylinders. =
;   Source has been well documented.                                    =
;                                                                       =
;========================================================================

#include "ti86asm.inc"
#include "Asm86.h"
#include "Rom86.h"

;.plugin lite86;                     ;the ultimate compression rutine

_ioprompt   =$c324
_asap_ind   =$d623
_getcode    =$4068

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp Start                        ;jump to Start
    .dw 0                           ;type of input
    .dw String3                     ;print string

String3: .db "Cylinders",0
#include "BMP2ASM.asm"

Start:
    call _flushallmenus             ;clears all key codes
    call _clrScrn                   ;clears the lcd and graph screen
    call _runindicoff               ;turn off run indicator
    ld hl,Prgm-1                    ;loads hl with prgm name to execute
    rst 20h                         ;op1 = name of 2nd asm prog to call
    rst 10h                         ;call _findsym, see if variable exists
    jp c,Text3                      ;if not jump to Text3
    ld de,Picture                   ;load picture into de
    call decompV                    ;goes to decompV
    call _exec_assembly             ;execute prgm in op1
Start2:
    ld hl,$1A05                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String4                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$210A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String5                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$270A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String6                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3405                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String9                   ;loads hl with string
    call _vputs                     ;prints in small text

Equation1:
    ld hl,$2105                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2705                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String7                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3A0A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String10                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey1:
    call _getcode                   ;stores key pressed into a
    cp K_ALPHA                      ;compare a with ALPHA
    call z,CalcOff                  ;if ALPHA goe to CalcOff
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_DOWN                       ;compares a with DOWN
    jr z,Equation2                  ;if DOWN relative jump to Equation2
    cp K_F1                         ;compares a with F1
    jr z,VAR1                       ;if F1 relative jump to VAR1
    cp K_F2                         ;compares a with F2
    jr z,VAR2                       ;if F2 relative jump to VAR2
    cp K_F3                         ;compares a with F3
    jr z,VAR3                       ;if F3 relative jump to VAR3
    jr GetKey1                      ;relative jump to GetKey1

Equation2:
    ld hl,$2105                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String7                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2705                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3A43                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String11                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey2:
    call _getcode                   ;stores key pressed into a
    cp K_ALPHA                      ;compare a with ALPHA
    call z,CalcOff                  ;if ALPHA goe to CalcOff
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_UP                         ;compares a with UP
    jr z,Equation1                  ;if UP relative jump to Equation1
    cp K_F1                         ;compares a with F1
    jr z,VAR4                       ;if F1 relative jump to VAR1
    cp K_F2                         ;compares a with F2
    jr z,VAR5                       ;if F2 relative jump to VAR2
    cp K_F3                         ;compares a with F3
    jr z,VAR6                       ;if F3 relative jump to VAR3
    jr GetKey2                      ;relative jump to GetKey2

VAR1:
    call Text6                      ;goes to Text6
    call Text7                      ;goes to Text7
    call _SQROOT                    ;square root of OP1 ==> OP1
    ld hl,E3                        ;string to print
    jr Text2                        ;realtive jump to Text2

VAR2:
    call Text6                      ;goes to Text6
    call _op1toop4                  ;OP1 ==> OP4
    ld hl,E3                        ;string to print
    call Input                      ;goes to Input
    call _FPSQUARE                  ;OP1 ^2 => OP1
    call _op4toop2                  ;OP4 ==> OP2
    rst 28h                         ;OP1 * OP2 ==> OP1
    ld hl,E1                        ;string to print
    jr Text2                        ;realtive jump to Text2

VAR3:
    call Text1                      ;goes to Text1
    ld hl,E3                        ;string to print
    call Input                      ;goes to Input
    call _FPSQUARE                  ;OP1 ^2 ==> OP1
    ld hl,Pie                       ;load hl with Pie
    call _mov10toop2                ;move 10 bytes @ hl to OP2
    rst 28h                         ;OP1 * OP2 ==> OP1
    call Text7                      ;goes to Text7
    ld hl,E4                        ;string to print
    jr Text2                        ;realtive jump to Text2

VAR4:
    call Text4                      ;goes to Text4
    ld hl,E4                        ;string to print
    call Input                      ;goes to Input
    rst 28h                         ;OP1 * OP2 ==> OP1
    rst 08h                         ;OP1 ==> OP2
    ld hl,E2                        ;string to print
    call Input                      ;goes to Input
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    ld hl,E3                        ;string to print
    jr Text2                        ;realtive jump to Text2

VAR5:
    call Text5                      ;goes to Text5
    ld hl,E2                        ;string to print
    call Input                      ;goes to Input
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    ld hl,E4                        ;string to print
    jr Text2                        ;realtive jump to Text2

VAR6:
    call Text5                      ;goes to Text5
    ld hl,E4                        ;string to print
    call Input                      ;goes to Input
    rst 28h                         ;OP1 * OP2 ==> OP1
    ld hl,E2                        ;string to print
    jr Text2                        ;realtive jump to Text2

Text1:
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    ret                             ;return to call

Text2:
    call _puts                      ;prints string
    call DispAnswer                 ;goes to DispAnswer
    call _getkey                    ;waits for a key to be pressed
    jp Start                        ;jumps to Start

Text3:
    ld hl,$0000                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String1                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$0700                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String2                   ;loads hl with string
    call _vputs                     ;prints in small text
    call _getkey                    ;waits for a key to be pressed
    jp Start2                       ;jump to Start2

Text4:
    call Text1                      ;goes to Text1
    ld a,2                          ;loads a with 2
    call _setXXop1                  ;moves value @ a to OP1
    ld hl,Pie                       ;load hl with Pie
    call _mov10toop2                ;move 10 bytes @ hl to OP2
    rst 28h                         ;OP1 * OP2 ==> OP1
    rst 08h                         ;OP1 ==> OP2
    ret                             ;return to call

Text5:
    call Text4                      ;goes to Text4
    ld hl,E3                        ;string to print
    call Input                      ;goes to Input
    rst 28h                         ;OP1 * OP2 ==> OP1
    rst 08h                         ;OP1 ==> OP2
    ret                             ;return to call

Text6:
    call Text1                      ;goes to Text1
    ld hl,Pie                       ;load hl with Pie
    call _mov10toop2                ;move 10 bytes @ hl to OP2
    ld hl,E4                        ;string to print
    call Input                      ;goes to Input
    rst 28h                         ;OP1 * OP2 ==> OP1
    ret                             ;return to call

Text7:
    rst 08h                         ;OP1 ==> OP2
    ld hl,E1                        ;string to print
    call Input                      ;goes to Input
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    ret                             ;return to call

Input:
    ld de,_ioprompt                 ;$c324 - string storage for display when prompte
    call _mov10b                    ;$427b - move 10 bytes from hl to de
    ld a,$0d                        ;type of input
                                    ;$0d - # value
                                    ;$0c - string
    ld (_asap_ind),a                ;$d623 - tell ti86 what kind to be inputted
    jp _exec_pg3                    ;$5714 - ti86 os input
                                    ;the number inputted is always stored to OP1
    ret                             ;return to call

DispAnswer:
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _puts                      ;prints answer
    call _runindicoff               ;turn off run indicator
    ret                             ;return to call

CalcOff:
    ld a,1
    out (3),a
    halt
    ld a,11                         ;turns off calculator???
    out (3),a        
    res onInterrupt,(iy+onflags)
    ret

Exit:
    res 3,(iy+5)                    ;reverts text back to black on white
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;moves cursor to upper left
    ret                             ;return that exits the program

Pie:                                ;Pie
    .db $00,$00,$FC,$31,$41,$59,$26,$53,$58,$97

String1:    .db "Written By Morgan Davies",0
String2:    .db "Missing File      ",34,"-geo.86p",34,"",0
String4:    .db "Equations:",0
String5:    .db "V=",196,"r",18,"H",0
String6:    .db "L.S.A.=2",196,"r(H)",0
String7:    .db 32,32,32,0
String8:    .db 5,0
String9:    .db "Solve For?",0
String10:   .db "F1= r     F2= H     F3= Volume",0
String11:   .db "L.S.A.      ",0
Prgm:       .db 4,"",45,"geo"
E1:     .db "Volume=?",0
E2:     .db "L.S.A.=?",0
E3:     .db "r=?",0
E4:     .db "H=?",0

Picture:
    .db $B7, $00, $FF, $B7, $00, $FF, $B7, $00, $9B, $01, $06, $08, $10, $B7, $20, $04
    .db $30, $28, $26, $21, $B7, $20, $0F, $10, $08, $06, $01, $B7, $00, $20, $3F, $C0
    .db $00, $00, $00, $01, $03, $01, $B7, $00, $04, $C0, $3F, $B7, $00, $11, $C0, $3F
    .db $B7, $00, $1F, $F8, $07, $B7, $00, $04, $AA, $00, $50, $60, $40, $40, $07, $F8
    .db $B7, $00, $11, $07, $F8, $B7, $00, $21, $C0, $20, $10, $08, $A8, $08, $08, $18
    .db $28, $C8, $B7, $08, $04, $B7, $09, $05, $B7, $08, $07, $10, $20, $C0, $B7, $00
    .db $31, $40, $40, $C0, $40, $40, $B7, $00, $54

.end
END