;========================================================================
;                                                                       =
;                          Geometry Solver v2.4                         =
;                            Right Triangles                            =
;                                                                       =
; Written By:   Morgan Davies (Morgazum85@Juno.com)                     =
; Date:         December 15, 2002                                       =
; Size:         843 Bytes                                               =
;                                                                       =
; Info: My next series in TI-86 is for Geometry. This program solves    =
;   for any varible from two different equations relating to right      =
;   triangles. Source is well documented.                               =
;                                                                       =
;========================================================================

#include "ti86asm.inc"
#include "Asm86.h"
#include "Rom86.h"

;.plugin lite86;                     ;the ultimate compression rutine

_ioprompt   =$c324
_asap_ind   =$d623
_getcode    =$4068

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp Start                        ;jump to Start
    .dw 0                           ;type of input
    .dw String3                     ;print string

String3: .db "Right Triangles",0
#include "BMP2ASM.asm"

Start:
    call _flushallmenus             ;clears all key codes
    call _clrScrn                   ;clears the lcd and graph screen
    call _runindicoff               ;turn off run indicator
    ld hl,Prgm-1                    ;loads hl with prgm name to execute
    rst 20h                         ;op1 = name of 2nd asm prog to call
    rst 10h                         ;call _findsym, see if variable exists
    jp c,Text3                      ;if not jump to Text3
    ld de,Picture                   ;load picture into de
    call decompV                    ;goes to decompV
    call _exec_assembly             ;execute prgm in op1
Start2:
    ld hl,$1A05                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String4                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$210A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String5                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$270A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String6                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3405                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String9                   ;loads hl with string
    call _vputs                     ;prints in small text

Equation1:
    ld hl,$2105                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2705                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String7                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3A0A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String10                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey1:
    call _getcode                   ;stores key pressed into a
    cp K_ALPHA                      ;compare a with ALPHA
    call z,CalcOff                  ;if ALPHA goe to CalcOff
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_DOWN                       ;compares a with DOWN
    jr z,Equation2                  ;if DOWN relative jump to Equation2
    cp K_F1                         ;compares a with F1
    jr z,VAR1                       ;if F1 relative jump to VAR1
    cp K_F2                         ;compares a with F2
    jr z,VAR2                       ;if F2 relative jump to VAR2
    cp K_F3                         ;compares a with F3
    jr z,VAR3                       ;if F3 relative jump to VAR3
    jr GetKey1                      ;relative jump to GetKey1

Equation2:
    ld hl,$2105                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String7                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2705                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3A43                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String11                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey2:
    call _getcode                   ;stores key pressed into a
    cp K_ALPHA                      ;compare a with ALPHA
    call z,CalcOff                  ;if ALPHA goe to CalcOff
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_UP                         ;compares a with UP
    jr z,Equation1                  ;if UP relative jump to Equation1
    cp K_F1                         ;compares a with F1
    jr z,VAR5                       ;if F1 relative jump to VAR1
    cp K_F2                         ;compares a with F2
    jr z,VAR4                       ;if F2 relative jump to VAR2
    cp K_F3                         ;compares a with F3
    jr z,VAR6                       ;if F3 relative jump to VAR3
    jr GetKey2                      ;relative jump to GetKey2

VAR1:
    call Text1                      ;goes to Text1
    ld hl,E2                        ;loads hl with string
    call Text4                      ;goes to Text4
    ld hl,E1                        ;loads hl with string
    jr Text2                        ;realtive jump to Text2

VAR2:
    call Text1                      ;goes to Text1
    ld hl,E1                        ;loads hl with string
    call Text4                      ;goes to Text4
    ld hl,E2                        ;loads hl with string
    jr Text2                        ;realtive jump to Text2

VAR3:
    call Text1                      ;goes to Text1
    ld hl,E1                        ;loads hl with string
    call Input                      ;goes to Input
    call _FPSQUARE                  ;OP1(A) ^2 ==> OP1
    call _op1toop4                  ;OP1(A^2) is stored in OP4
    ld hl,E2                        ;loads hl with string
    call Input                      ;goes to Input
    call _FPSQUARE                  ;OP1(B) ^2 ==> OP1
    call _op4toop2                  ;OP4(A^2) is moved to OP2
    rst 30h                         ;OP1(B^2) + OP2(A^2) ==> OP1
    call _SQROOT                    ;root of OP1(A^2 + B^2) ==> OP1
    ld hl,E3                        ;loads hl with string
    jr Text2                        ;realtive jump to Text2

VAR4:
    call Text1                      ;goes to Text1
    ld hl,E4                        ;loads hl with string
    call Text5                      ;goes to Text5
    ld hl,E2                        ;loads hl with string
    jr Text2                        ;realtive jump to Text2

VAR5:
    call Text1                      ;goes to Text1
    ld hl,E2                        ;loads hl with string
    call Input                      ;goes to Input
    call _TIMESPT5                  ;OP1(B) * .5 ==> OP1
    rst 08h                         ;OP1(.5B) is stored to OP2
    ld hl,E4                        ;loads hl with string
    call Input                      ;goes to Input
    rst 28h                         ;OP1(H) * OP2(.5B) ==> OP1
    ld hl,E1                        ;loads hl with string
    jr Text2                        ;realtive jump to Text2

VAR6:
    call Text1                      ;goes to Text1
    ld hl,E2                        ;loads hl with string
    call Text5                      ;goes to Text5
    ld hl,E4                        ;loads hl with string
    jr Text2                        ;realtive jump to Text2

Text1:
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    ret                             ;return to call

Text2:
    call _puts                      ;prints string
    call DispAnswer                 ;goes to DispAnswer
    call _getkey                    ;waits for a key to be pressed
    jp Start                        ;jumps to Start

Text3:
    ld hl,$0000                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String1                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$0700                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String2                   ;loads hl with string
    call _vputs                     ;prints in small text
    call _getkey                    ;waits for a key to be pressed
    jp Start2                       ;jump to Start2

Text4:
    call Input                      ;goes to Input
    call _FPSQUARE                  ;OP1(A) ^2 ==> OP1
    call _op1toop4                  ;OP1(A^2) is stored in OP4
    ld hl,E3                        ;loads hl with string
    call Input                      ;goes to Input
    call _FPSQUARE                  ;OP1(C) ^2 ==> OP1
    call _op4toop2                  ;OP4(A^2) is moved to OP2
    call _FPSUB                     ;OP1(C^2) - OP2(A^2) ==> OP1
    call _SQROOT                    ;root of OP1(C^2 - A^2) ==> OP1
    ret                             ;return to call

Text5:
    call Input                      ;goes to Input
    call _TIMESPT5                  ;OP1(H) * .5 ==> OP1
    rst 08h                         ;OP1(.5H) is stored to OP2
    ld hl,E1                        ;loads hl with string
    call Input                      ;goes to Input
    call _FPDIV                     ;OP1(A) / OP2(.5H) ==> OP1
    ret                             ;return to call

Input:
    ld de,_ioprompt                 ;$c324 - string storage for display when prompte
    call _mov10b                    ;$427b - move 10 bytes from hl to de
    ld a,$0d                        ;type of input
                                    ;$0d - # value
                                    ;$0c - string
    ld (_asap_ind),a                ;$d623 - tell ti86 what kind to be inputted
    jp _exec_pg3                    ;$5714 - ti86 os input
                                    ;the number inputted is always stored to OP1
    ret                             ;return to call

DispAnswer:
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _puts                      ;prints answer
    call _runindicoff               ;turn off run indicator
    ret                             ;return to call

CalcOff:
    ld a,1
    out (3),a
    halt
    ld a,11                         ;turns off calculator???
    out (3),a        
    res onInterrupt,(iy+onflags)
    ret

Exit:
    res 3,(iy+5)                    ;reverts text back to black on white
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;moves cursor to upper left
    ret                             ;return that exits the program

String1:    .db "Written By Morgan Davies",0
String2:    .db "Missing File      ",34,"-geo.86p",34,"",0
String4:    .db "Equations:",0
String5:    .db "A",18,"+B",18,"=C",18,""0
String6:    .db "A=1/2(B)(H)",0
String7:    .db 32,32,32,0
String8:    .db 5,0
String9:    .db "Solve For?",0
String10:   .db "F1= A     F2= B     F3= C",0
String11:   .db "H",0
Prgm:       .db 4,"",45,"geo"
E1:     .db "A=?",0
E2:     .db "B=?",0
E3:     .db "C=?",0
E4:     .db "H=?",0

Picture:
    .db $B7, $00, $FF, $B7, $00, $FF, $B7, $00, $35, $01, $03, $B7, $00, $3A, $01, $06
    .db $18, $60, $80, $FF, $B7, $00, $36, $01, $06, $18, $60, $80, $B7, $00, $04, $FF
    .db $B7, $00, $2C, $30, $40, $40, $40, $30, $00, $01, $06, $18, $60, $80, $B7, $00
    .db $08, $FF, $00, $00, $B7, $01, $05, $B7, $00, $27, $01, $06, $18, $60, $80, $B7
    .db $00, $0C, $FF, $00, $00, $80, $40, $80, $40, $80, $B7, $00, $23, $01, $06, $18
    .db $60, $80, $B7, $00, $10, $FF, $B7, $00, $27, $04, $1C, $64, $84, $B7, $04, $10
    .db $7C, $44, $44, $44, $FC, $B7, $00, $32, $40, $A0, $E0, $A0, $A0, $B7, $00, $15

.end
END