;========================================================================
;                                                                       =
;                          Geometry Solver v2.4                         =
;                           Sectors of a Circle                         =
;                                                                       =
; Written By:   Morgan Davies (Morgazum85@Juno.com)                     =
; Date:         December 22, 2002                                       =
; Size:         865 Bytes                                               =
;                                                                       =
; Info: My next series in TI-86 is for Geometry. This program solves    =
;   for any varible from two different equations relating to sectors    =
;   of a circle. Source has been well documented.                       =
;                                                                       =
;========================================================================

#include "ti86asm.inc"
#include "Asm86.h"
#include "Rom86.h"

;.plugin lite86;                     ;the ultimate compression rutine

_ioprompt   =$c324
_asap_ind   =$d623
_getcode    =$4068

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp Start                        ;jump to Start
    .dw 0                           ;type of input
    .dw String3                     ;print string

String3: .db "Sectors of a Circle",0
#include "BMP2ASM.asm"

Start:
    call _flushallmenus             ;clears all key codes
    call _clrScrn                   ;clears the lcd and graph screen
    call _runindicoff               ;turn off run indicator
    ld hl,Prgm-1                    ;loads hl with prgm name to execute
    rst 20h                         ;op1 = name of 2nd asm prog to call
    rst 10h                         ;call _findsym, see if variable exists
    jp c,Text3                      ;if not jump to Text3
    ld de,Picture                   ;load picture into de
    call decompV                    ;goes to decompV
    call _exec_assembly             ;execute prgm in op1
Start2:
    ld hl,$1A05                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String4                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$210A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String5                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$270A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String6                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3405                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String9                   ;loads hl with string
    call _vputs                     ;prints in small text

Equation1:
    ld hl,$2105                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2705                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String7                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3A0A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String10                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey1:
    call _getcode                   ;stores key pressed into a
    cp K_ALPHA                      ;compare a with ALPHA
    call z,CalcOff                  ;if ALPHA goe to CalcOff
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_DOWN                       ;compares a with DOWN
    jr z,Equation2                  ;if DOWN relative jump to Equation2
    cp K_F1                         ;compares a with F1
    jr z,VAR1                       ;if F1 relative jump to VAR1
    cp K_F2                         ;compares a with F2
    jr z,VAR2                       ;if F2 relative jump to VAR2
    cp K_F3                         ;compares a with F3
    jr z,VAR3                       ;if F3 relative jump to VAR3
    jr GetKey1                      ;relative jump to GetKey1

Equation2:
    ld hl,$2105                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String7                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2705                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3A43                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String11                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey2:
    call _getcode                   ;stores key pressed into a
    cp K_ALPHA                      ;compare a with ALPHA
    call z,CalcOff                  ;if ALPHA goe to CalcOff
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_UP                         ;compares a with UP
    jr z,Equation1                  ;if UP relative jump to Equation1
    cp K_F1                         ;compares a with F1
    jr z,VAR4                       ;if F1 relative jump to VAR1
    cp K_F2                         ;compares a with F2
    jr z,VAR5                       ;if F2 relative jump to VAR2
    cp K_F3                         ;compares a with F3
    jr z,VAR6                       ;if F3 relative jump to VAR3
    jr GetKey2                      ;relative jump to GetKey2

VAR1:
    call Text1                      ;goes to Text1
    ld hl,E4                        ;string to print
    call Text4                      ;goes to Text4
    ld hl,E2                        ;string to print
    jp Text2                        ;realtive jump to Text2

VAR2:
    call Text1                      ;goes to Text1
    ld hl,E2                        ;string to print
    call Text4                      ;goes to Text4
    ld hl,E4                        ;string to print
    jp Text2                        ;realtive jump to Text2

VAR3:
    call Text1                      ;goes to Text1
    ld hl,E2                        ;string to print
    call Input                      ;goes to Input
    rst 08h                         ;OP1 ==> OP2
    ld hl,E4                        ;string to print
    call Input                      ;goes to Input
    rst 28h                         ;OP1 * OP2 ==> OP1
    ld hl,E3                        ;string to print
    jr Text2                        ;realtive jump to Text2

VAR4:
    call Text1                      ;goes to Text1
    ld a,2                          ;loads a with 2
    call _setXXop2                  ;moves value @ a to OP2
    ld hl,E4                        ;string to print
    call Input                      ;goes to Input
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    rst 08h                         ;OP1 ==> OP2
    ld hl,E1                        ;string to print
    call Input                      ;goes to Input
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    call _SQROOT                    ;square root of OP1 ==> OP1
    ld hl,E2                        ;string to print
    jr Text2                        ;realtive jump to Text2

VAR5:
    call Text1                      ;goes to Text1
    ld hl,E2                        ;string to print
    call Input                      ;goes to Input
    call _FPSQUARE                  ;OP1 ^2 ==> OP1
    call _op1toop4                  ;OP1 ==> OP4
    ld a,2                          ;loads a with 2
    call _setXXop2                  ;moves value @ a to OP2
    ld hl,E1                        ;string to print
    call Input                      ;goes to Input
    rst 28h                         ;OP1 * OP2 ==> OP1
    call _op4toop2                  ;OP4 ==> OP2
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    ld hl,E4                        ;string to print
    jr Text2                        ;realtive jump to Text2

VAR6:
    call Text1                      ;goes to Text1
    ld hl,E4                        ;string to print
    call Input                      ;goes to Input
    call _op1toop4                  ;OP1 ==> OP4
    ld hl,E2                        ;string to print
    call Input                      ;goes to Input
    call _FPSQUARE                  ;OP1 ^2 ==> OP1
    call _op4toop2                  ;OP4 ==> OP2
    rst 28h                         ;OP1 * OP2 ==> OP1
    ld a,2                          ;loads a with 2
    call _setXXop2                  ;moves value @ a to OP2
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    ld hl,E1                        ;string to print
    jr Text2                        ;realtive jump to Text2

Text1:
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    ret                             ;return to call

Text2:
    call _puts                      ;prints string
    call DispAnswer                 ;goes to DispAnswer
    call _getkey                    ;waits for a key to be pressed
    jp Start                        ;jumps to Start

Text3:
    ld hl,$0000                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String1                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$0700                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String2                   ;loads hl with string
    call _vputs                     ;prints in small text
    call _getkey                    ;waits for a key to be pressed
    jp Start2                       ;jump to Start2

Text4:
    call Input                      ;goes to Input
    rst 08h                         ;OP1 ==> OP2
    ld hl,E3                        ;string to print
    call Input                      ;goes to Input
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    ret                             ;return to call

Input:
    ld de,_ioprompt                 ;$c324 - string storage for display when prompte
    call _mov10b                    ;$427b - move 10 bytes from hl to de
    ld a,$0d                        ;type of input
                                    ;$0d - # value
                                    ;$0c - string
    ld (_asap_ind),a                ;$d623 - tell ti86 what kind to be inputted
    jp _exec_pg3                    ;$5714 - ti86 os input
                                    ;the number inputted is always stored to OP1
    ret                             ;return to call

DispAnswer:
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _puts                      ;prints answer
    call _runindicoff               ;turn off run indicator
    ret                             ;return to call

CalcOff:
    ld a,1
    out (3),a
    halt
    ld a,11                         ;turns off calculator???
    out (3),a        
    res onInterrupt,(iy+onflags)
    ret

Exit:
    res 3,(iy+5)                    ;reverts text back to black on white
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;moves cursor to upper left
    ret                             ;return that exits the program

String1:    .db "Written By Morgan Davies",0
String2:    .db "Missing File      ",34,"-geo.86p",34,"",0
String4:    .db "Equations:",0
String5:    .db "S=(R)(",193,")"0
String6:    .db "Area=",193,"R",18,"/2",0
String7:    .db 32,32,32,0
String8:    .db 5,0
String9:    .db "Solve For?",0
String10:   .db "F1= R     F2= ",193,"     F3= S           ",0
String11:   .db "Area",0
Prgm:       .db 4,"",45,"geo"
E1:     .db "Area=?",0
E2:     .db "R=?",0
E3:     .db "S=?",0
E4:     .db "",193,21,"=?",0

Picture:
    .db $B7, $00, $FF, $B7, $00, $FF, $B7, $00, $73, $01, $06, $18, $3F, $B7, $00, $38
    .db $01, $06, $18, $60, $80, $00, $00, $FF, $B7, $00, $34, $01, $06, $18, $60, $80
    .db $20, $50, $70, $50, $20, $00, $FF, $00, $03, $02, $03, $02, $02, $B7, $00, $2A
    .db $01, $06, $18, $60, $80, $B7, $00, $0A, $FF, $00, $00, $80, $00, $80, $80, $B7
    .db $00, $26, $01, $06, $18, $60, $80, $B7, $00, $0E, $FF, $B7, $00, $2D, $80, $80
    .db $40, $40, $40, $23, $24, $22, $11, $16, $10, $10, $10, $B7, $08, $05, $F8, $B7
    .db $00, $4C

.end
END