;========================================================================
;                                                                       =
;                          Geometry Solver v2.4                         =
;                                Triangle                               =
;                                                                       =
; Written By:   Morgan Davies (Morgazum85@Juno.com)                     =
; Date:         December 28, 2002                                       =
; Size:         1165 Bytes                                              =
;                                                                       =
; Info: My next series in TI-86 is for Geometry. This program solves    =
;   for any varible from three different equations relating to          =
;   Triangles. Source has been well documented.                         =
;                                                                       =
;========================================================================

#include "ti86asm.inc"
#include "Asm86.h"
#include "Rom86.h"

;.plugin lite86;                     ;the ultimate compression rutine

_ioprompt   =$c324
_asap_ind   =$d623
_getcode    =$4068

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp Start                        ;jump to Start
    .dw 0                           ;type of input
    .dw String3                     ;print string

String3: .db "Triangles",0
#include "BMP2ASM.asm"

Start:
    set trigdeg,(iy+trigflags)      ;turns on degree mode
    call _flushallmenus             ;clears all key codes
    call _clrScrn                   ;clears the lcd and graph screen
    call _runindicoff               ;turn off run indicator
    ld hl,Prgm-1                    ;loads hl with prgm name to execute
    rst 20h                         ;op1 = name of 2nd asm prog to call
    rst 10h                         ;call _findsym, see if variable exists
    jp c,Text3                      ;if not jump to Text3
    ld de,Picture                   ;load picture into de
    call decompV                    ;goes to decompV
    call _exec_assembly             ;execute prgm in op1
Start2:
    ld hl,$1805                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String4                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$1F0A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String5                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$250A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String6                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2B0A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String7                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3405                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String10                  ;loads hl with string
    call _vputs                     ;prints in small text

Equation1:
    ld hl,$1F05                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String9                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2505                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3A0A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String11                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey1:
    call _getcode                   ;stores key pressed into a
    cp K_ALPHA                      ;compare a with ALPHA
    call z,CalcOff                  ;if ALPHA goe to CalcOff
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_DOWN                       ;compares a with DOWN
    jr z,Equation2                  ;if DOWN jump to Equation2
    cp K_F1                         ;compares a with F1
    jp z,VAR1                       ;if F1 jump to VAR1
    cp K_F2                         ;compares a with F2
    jp z,VAR2                       ;if F2 jump to VAR2
    jr GetKey1                      ;jump to GetKey1

Equation2:
    ld hl,$1F05                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2505                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String9                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2B05                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3A0A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String12                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey2:
    call _getcode                   ;stores key pressed into a
    cp K_ALPHA                      ;compare a with ALPHA
    call z,CalcOff                  ;if ALPHA goe to CalcOff
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_UP                         ;compares a with UP
    jp z,Equation1                  ;if UP jump to Equation1
    cp K_DOWN                       ;compares a with DOWN
    jr z,Equation3                  ;if DOWN jump to Equation3
    cp K_F1                         ;compares a with F1
    jp z,VAR3                       ;if F1 jump to VAR3
    cp K_F2                         ;compares a with F2
    jp z,VAR4                       ;if F2 jump to VAR4
    cp K_F3                         ;compares a with F3
    jp z,VAR5                       ;if F3 jump to VAR5
    jr GetKey2                      ;jump to GetKey2

Equation3:
    ld hl,$2505                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2B05                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String9                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3A0A                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String13                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey3:
    call _getcode                   ;stores key pressed into a
    cp K_ALPHA                      ;compare a with ALPHA
    call z,CalcOff                  ;if ALPHA goe to CalcOff
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_UP                         ;compares a with UP
    jp z,Equation2                  ;if UP jump to Equation2
    cp K_F1                         ;compares a with F1
    jp z,VAR6                       ;if F1 jump to VAR6
    cp K_F2                         ;compares a with F2
    jp z,VAR7                       ;if F2 jump to VAR7
    cp K_F3                         ;compares a with F3
    jp z,VAR8                       ;if F3 jump to VAR8
    jr GetKey3                      ;jump to GetKey2

VAR1:
    call Text4                      ;goes to Text4
    ld hl,E6                        ;string to print
    call Input                      ;goes to Input
    call _COS                       ;cosine OP1 ==> OP1
    call _op6toop2                  ;OP6 ==> OP2
    rst 28h                         ;OP1 * OP2 ==> OP1
    rst 08h                         ;OP1 ==> OP2
    call _rclX                      ;X ==> OP1
    call _FPSUB                     ;OP1 - OP2 ==> OP1
    call _SQROOT                    ;square root OP1 ==> OP1
    ld hl,E3                        ;string to print
    jp Text2                        ;jump to Text2

VAR2:
    call Text4                      ;goes to Text4
    ld hl,E3                        ;string to print
    call Input                      ;goes to Input
    call _FPSQUARE                  ;OP1 ^2 ==> OP1
    rst 08h                         ;OP1 ==> OP2
    call _rclX                      ;X ==> OP1
    call _FPSUB                     ;OP1 - OP2 ==> OP1
    call _op6toop2                  ;OP6 ==> OP2
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    call _ACOS                      ;inverse cosine OP1 ==> OP1
    ld hl,E6                        ;string to print
    jr Text2                        ;jump to Text2

VAR3:
    call Text5                      ;goes to Text5
    ld hl,E4                        ;string to print
    call Input                      ;goes to Input
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    ld hl,E1                        ;string to print
    jr Text2                        ;jump to Text2

VAR4:
    call Text1                      ;goes to Text1
    ld hl,E1                        ;string to print
    call Input                      ;goes to Input
    rst 08h                         ;OP1 ==> OP2
    ld hl,E4                        ;string to print
    call Input                      ;goes to Input
    call _FPDIV                     ;OP1 / OP2 ==> OP1
    call _ASIN                      ;inverse sine OP1 ==> OP1
    ld hl,E6                        ;string to print
    jr Text2                        ;jump to Text2

VAR5:
    call Text5                      ;goes to Text5
    ld hl,E1                        ;string to print
    call Input                      ;goes to Input
    rst 28h                         ;OP1 * OP2 ==> OP1
    ld hl,E4                        ;string to print
    jr Text2                        ;jump to Text2

VAR6:
    call Text1                      ;goes to Text1
    ld hl,E4                        ;string to print
    call Text6                      ;goes to Text6
    ld hl,E2                        ;string to print
    jr Text2                        ;jump to Text2

VAR7:
    call Text1                      ;goes to Text1
    ld hl,E2                        ;string to print
    call Text6                      ;goes to Text6
    ld hl,E4                        ;string to print
    jr Text2                        ;jump to Text2

VAR8:
    call Text1                      ;goes to Text1
    ld hl,E4                        ;string to print
    call Input                      ;goes to Input
    call _TIMESPT5                  ;OP1 * .5 ==> OP1
    rst 08h                         ;OP1 ==> OP2
    ld hl,E2                        ;string to print
    call Input                      ;goes to Input
    rst 28h                         ;OP1 * OP2 ==> OP1
    ld hl,E5                        ;string to print
    jr Text2                        ;jump to Text2

Text1:
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    ret                             ;return to call

Text2:
    call _puts                      ;prints string
    call DispAnswer                 ;goes to DispAnswer
    call _getkey                    ;waits for a key to be pressed
    jp Start                        ;jumps to Start

Text3:
    ld hl,$0000                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String1                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$0700                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String2                   ;loads hl with string
    call _vputs                     ;prints in small text
    call _getkey                    ;waits for a key to be pressed
    jp Start2                       ;jump to Start2

Text4:
    call Text1                      ;goes to Text1
    ld hl,E1                        ;string to print
    call Input                      ;goes to Input
    call _stoY                      ;OP1 ==> Y
    call _FPSQUARE                  ;OP1 ^2 ==> OP1
    call _op1toop6                  ;OP1 ==> OP6
    ld hl,E2                        ;string to print
    call Input                      ;goes to Input
    call _stoX                      ;OP1 ==> X
    call _FPSQUARE                  ;OP1 ^2 ==> OP1
    call _op6toop2                  ;OP6 ==> OP2
    rst 30h                         ;OP1 + OP2 ==> OP1
    call _op1toop4                  ;OP1 ==> OP4
    call _rclX                      ;X ==> OP1
    rst 08h                         ;OP1 ==> OP2
    call _rclY                      ;Y ==> OP1
    rst 28h                         ;OP1 * OP2 ==> OP1
    ld a,2                          ;load a with 2
    call _setXXop2                  ;move value @ a to OP2
    rst 28h                         ;OP1 * OP2 ==> OP1
    call _op1toop6                  ;OP1 ==> OP6
    call _op4toop1                  ;OP4 ==> OP1
    call _stoX                      ;OP1 ==> X
    ret                             ;return to call

Text5:
    call Text1                      ;goes to Text1
    ld hl,E6                        ;string to print
    call Input                      ;goes to Input
    call _SIN                       ;sine OP1 ==> OP1
    rst 08h                         ;OP1 ==> OP2
    ret                             ;return to call

Text6:
    call Input                      ;goes to Input
    call _TIMESPT5                  ;OP1 * .5 ==> OP1
    rst 08h                         ;OP1 ==> OP2
    ld hl,E5                        ;string to print
    call Input                      ;goes to Input
    call _FPDIV                     ;OP1 / OP2 => OP1
    ret                             ;return to call

Input:
    ld de,_ioprompt                 ;$c324 - string storage for display when prompte
    call _mov10b                    ;$427b - move 10 bytes from hl to de
    ld a,$0d                        ;type of input
                                    ;$0d - # value
                                    ;$0c - string
    ld (_asap_ind),a                ;$d623 - tell ti86 what kind to be inputted
    jp _exec_pg3                    ;$5714 - ti86 os input
                                    ;the number inputted is always stored to OP1
    ret                             ;return to call

DispAnswer:
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _puts                      ;prints answer
    call _runindicoff               ;turn off run indicator
    ret                             ;return to call

CalcOff:
    ld a,1
    out (3),a
    halt
    ld a,11                         ;turns off calculator???
    out (3),a        
    res onInterrupt,(iy+onflags)
    ret

Exit:
    res 3,(iy+5)                    ;reverts text back to black on white
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;moves cursor to upper left
    ret                             ;return that exits the program

String1:    .db "Written By Morgan Davies",0
String2:    .db "Missing File      ",34,"-geo.86p",34,0
String4:    .db "Equations:",0
String5:    .db "C",18,"=A",18,"+B",18,"-2AB cos ",193,0
String6:    .db "H=A sin ",193,0
String7:    .db "Area=1/2(B)(H)",0
String8:    .db 32,32,32,0
String9:    .db 5,0
String10:   .db "Solve For?",0
String11:   .db "F1= C     F2= ",193,"                     "0
String12:   .db "F1= A     F2= ",193,"     F3= H           ",0
String13:   .db "F1= B     F2= H     F3= Area",0
Prgm:       .db 4,"",45,"geo"
E1:     .db "A=?",0
E2:     .db "B=?",0
E3:     .db "C=?",0
E4:     .db "H=?",0
E5:     .db "Area=?",0
E6:     .db 193,20,"=?",0

Picture:
    .db $B7, $00, $FF, $B7, $00, $FF, $B7, $00, $73, $01, $06, $18, $60, $FF, $B7, $00
    .db $30, $03, $04, $04, $04, $03, $00, $00, $01, $06, $18, $60, $80, $00, $00, $00
    .db $FF, $B7, $00, $33, $01, $06, $18, $60, $80, $B7, $00, $07, $FF, $B7, $00, $2F
    .db $01, $06, $18, $60, $80, $00, $00, $05, $05, $07, $05, $05, $B7, $00, $04, $FF
    .db $00, $30, $28, $30, $28, $30, $B7, $00, $28, $40, $A0, $50, $08, $44, $02, $41
    .db $00, $40, $00, $40, $00, $40, $00, $40, $00, $40, $FF, $B7, $00, $31, $08, $14
    .db $1C, $14, $94, $40, $20, $10, $48, $A4, $E2, $A1, $40, $00, $FF, $B7, $00, $3D
    .db $80, $40, $E0, $B7, $00, $0B

.end
END